"""
    Sifflet Backend API

    Requirements: <br>    - [Create your access token through the UI](https://docs.siffletdata.com/docs/generate-an-api-token#create-an-api-token) <br>    - Get your tenant name: if you access to Sifflet with `https://abcdef.siffletdata.com`, then your tenant would be `abcdef`  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from sifflet_sdk.client.api_client import ApiClient, Endpoint as _Endpoint
from sifflet_sdk.client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from sifflet_sdk.client.model.problem import Problem
from sifflet_sdk.client.model.slack_workspace_config_dto import SlackWorkspaceConfigDto
from sifflet_sdk.client.model.system_alert_config_dto import SystemAlertConfigDto


class ConfigApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_or_update_system_alert_config_endpoint = _Endpoint(
            settings={
                'response_type': None,
                'auth': [
                    'JWT'
                ],
                'endpoint_path': '/ui/v1/configs/{systemAlertConfigName}',
                'operation_id': 'create_or_update_system_alert_config',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'system_alert_config_name',
                    'system_alert_config_dto',
                ],
                'required': [
                    'system_alert_config_name',
                    'system_alert_config_dto',
                ],
                'nullable': [
                ],
                'enum': [
                    'system_alert_config_name',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('system_alert_config_name',): {

                        "SLACK_BOT_CONNECTED": "SLACK_BOT_CONNECTED",
                        "SYSTEM_ALERT_SLACK_WORKSPACE_NAME": "SYSTEM_ALERT_SLACK_WORKSPACE_NAME",
                        "MS_TEAMS_WEBHOOK_ENABLED": "MS_TEAMS_WEBHOOK_ENABLED"
                    },
                },
                'openapi_types': {
                    'system_alert_config_name':
                        (str,),
                    'system_alert_config_dto':
                        (SystemAlertConfigDto,),
                },
                'attribute_map': {
                    'system_alert_config_name': 'systemAlertConfigName',
                },
                'location_map': {
                    'system_alert_config_name': 'path',
                    'system_alert_config_dto': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/problem+json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.get_slack_workspace_config_endpoint = _Endpoint(
            settings={
                'response_type': (SlackWorkspaceConfigDto,),
                'auth': [
                    'JWT'
                ],
                'endpoint_path': '/ui/v1/configs/slack/workspace',
                'operation_id': 'get_slack_workspace_config',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                },
                'attribute_map': {
                },
                'location_map': {
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json',
                    'application/problem+json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_system_alert_config_endpoint = _Endpoint(
            settings={
                'response_type': (SystemAlertConfigDto,),
                'auth': [
                    'JWT'
                ],
                'endpoint_path': '/ui/v1/configs/{systemAlertConfigName}',
                'operation_id': 'get_system_alert_config',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'system_alert_config_name',
                ],
                'required': [
                    'system_alert_config_name',
                ],
                'nullable': [
                ],
                'enum': [
                    'system_alert_config_name',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('system_alert_config_name',): {

                        "SLACK_BOT_CONNECTED": "SLACK_BOT_CONNECTED",
                        "SYSTEM_ALERT_SLACK_WORKSPACE_NAME": "SYSTEM_ALERT_SLACK_WORKSPACE_NAME",
                        "MS_TEAMS_WEBHOOK_ENABLED": "MS_TEAMS_WEBHOOK_ENABLED"
                    },
                },
                'openapi_types': {
                    'system_alert_config_name':
                        (str,),
                },
                'attribute_map': {
                    'system_alert_config_name': 'systemAlertConfigName',
                },
                'location_map': {
                    'system_alert_config_name': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json',
                    'application/problem+json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def create_or_update_system_alert_config(
        self,
        system_alert_config_name,
        system_alert_config_dto,
        **kwargs
    ):
        """Update a system alert config  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_or_update_system_alert_config(system_alert_config_name, system_alert_config_dto, async_req=True)
        >>> result = thread.get()

        Args:
            system_alert_config_name (str):
            system_alert_config_dto (SystemAlertConfigDto):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            None
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['system_alert_config_name'] = \
            system_alert_config_name
        kwargs['system_alert_config_dto'] = \
            system_alert_config_dto
        return self.create_or_update_system_alert_config_endpoint.call_with_http_info(**kwargs)

    def get_slack_workspace_config(
        self,
        **kwargs
    ):
        """Fetch the value of a Slack workspace  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_slack_workspace_config(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            SlackWorkspaceConfigDto
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        return self.get_slack_workspace_config_endpoint.call_with_http_info(**kwargs)

    def get_system_alert_config(
        self,
        system_alert_config_name,
        **kwargs
    ):
        """Fetch the value of a system alert config  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_system_alert_config(system_alert_config_name, async_req=True)
        >>> result = thread.get()

        Args:
            system_alert_config_name (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            SystemAlertConfigDto
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['system_alert_config_name'] = \
            system_alert_config_name
        return self.get_system_alert_config_endpoint.call_with_http_info(**kwargs)
